<script lang="ts">
	import { createEventDispatcher } from 'svelte'
	import { formatTime } from '../helpers'

	interface Props {
		routeName?: string;
		timestamp?: number;
		distanceKM?: number;
		comment?: string;
		iconUrl?: string;
	}

	let {
		routeName = 'Route Name',
		timestamp = 0,
		distanceKM = 0,
		comment = 'No comment',
		iconUrl = '/unknown.png'
	}: Props = $props();

	let timeAgo = `${formatTime(Date.now() - timestamp)} ago`
	let timeString = $state(timeAgo)
	let event = createEventDispatcher()

	function onHover() {
		timeString = new Date(timestamp).toLocaleString('en-gb', { dateStyle: 'full' })
	}

	function onMouseOut() {
		timeString = timeAgo
	}

	function onClick(e: Event) {
		event('click', this)
	}
</script>

<!-- markup (zero or more items) goes here -->
<div class="container">
	<div class="avatar">
		<img src={iconUrl} alt="{routeName} icon" />
	</div>

	<div class="title">
		<h2>{routeName}</h2>
	</div>

	<div class="time">
		<p onmouseout={onMouseOut} onmouseover={onHover} onfocus={onHover} onblur={onMouseOut}>({timeString})</p>
	</div>

	<h3 class="drops">{distanceKM} km</h3>
	<!-- {#if comment} -->
	<h4 class="comment">{comment || 'No comment'}</h4>
	<!-- {/if} -->
</div>

<style>
	/* your styles go here */
	.container {
		background-color: #191919;
		border-radius: 5px;
		border-left-color: var(--accentColour);
		border-style: none none none solid;
		display: grid;
		grid-template-rows: 1fr 1fr auto;
		grid-template-columns: auto 1fr auto;
		grid-template-areas: 'name time icon' 'drops drops icon' 'comment comment icon';
		column-gap: 1rem;
		padding-right: 1rem;
		grid-column-end: 10px;
		user-select: none;
	}

	img {
		grid-area: icon;
		margin: auto;
		margin-right: 15px;
	}

	.container .title {
		grid-area: name;
		display: flex;
		margin-top: 15px;
	}

	.container .time {
		grid-area: time;
		display: flex;
		margin-top: 15px;
	}

	h2,
	h3,
	h4,
	p {
		font-weight: 500;
		display: inline;
		text-align: left;
		margin: 0px;
	}

	h2 {
		font-weight: 600;
		font-size: 1.3rem;
		color: #ccc;
		margin-left: 20px;
	}

	h3 {
		color: #ccc;
		margin-left: 20px;
	}

	h4,
	p {
		color: #aaa;
		margin-left: 10px;
		margin-top: 2px;
	}

	.drops {
		grid-area: drops;
		margin-top: 10px;
		margin-bottom: 15px;
	}

	.comment {
		grid-area: comment;
		margin-top: 10px;
		margin-bottom: 15px;
		margin-left: 20px;
	}

	.avatar {
		width: 96px;
		height: 96px;
		border-radius: 50%;
		margin-top: 1rem;
		margin-bottom: 1rem;
		overflow: hidden;
		display: inline-flex;
		align-items: center;
		justify-content: center;
		grid-area: icon;
		margin-top: auto;
		margin-bottom: auto;
	}

	.avatar img {
		margin: 0;
		width: 100%;
		height: 100%;
		object-fit: cover;
	}

	@media (max-width: 500px) {
		.avatar {
			width: 80px;
			height: 80px;
			margin-left: auto;
			margin-right: auto;
		}
	}

	@media (max-width: 450px) {
		.container {
			grid-template-rows: 1fr 1fr auto;
			grid-template-columns: auto 1fr;
			grid-template-areas: 'name time' 'drops icon' 'comment icon';
			column-gap: 1rem;
			padding-right: 1rem;
			grid-column-end: 10px;
			user-select: none;
		}

		.avatar {
			width: 64px;
			height: 64px;
			margin-left: auto;
			margin-right: auto;
		}
	}

	@media (max-width: 350px) {
		.avatar {
			width: 48px;
			height: 48px;
			margin-left: auto;
			margin-right: auto;
		}
	}

	@media (max-width: 300px) {
		.container {
			grid-template-rows: 1fr 1fr 1fr auto 1px;
			grid-template-columns: 1fr;
			grid-template-areas: 'name' 'time' 'drops' 'comment' 'icon';
			column-gap: 1rem;
			padding-right: 1rem;
			grid-column-end: 10px;
			user-select: none;
		}

		.avatar {
			display: none;
			width: 1px;
			height: 1px;
			margin-left: auto;
			margin-right: auto;
		}

		.time {
			margin-left: 20px;
		}

		.time h4 {
			margin-left: 0px;
		}
	}
</style>
